unit Differences;

interface

uses Basis;

function  Int_xy(f :TMathFunc; x,y,h,l :Float) :Float;
function  Int_x(f :TMathFunc; x,y,h :Float) :Float;
function  Int_y(f :TMathFunc; x,y,l :Float) :Float;

function  DifL_i(f :TMathFunc; x,y,h :Float) :Float;
function  DifR_i(f :TMathFunc; x,y,h :Float) :Float;
function  DifC_i(f :TMathFunc; x,y,h :Float) :Float;
function  Dif2_i(f :TMathFunc; x,y,h :Float) :Float;

function  DifL_j(f :TMathFunc; x,y,l :Float) :Float;
function  DifR_j(f :TMathFunc; x,y,l :Float) :Float;
function  DifC_j(f :TMathFunc; x,y,l :Float) :Float;
function  Dif2_j(f :TMathFunc; x,y,l :Float) :Float;

implementation

function  Int_xy(f :TMathFunc; x,y,h,l :Float) :Float;
begin
  Result := h*l*f(x+h/2,y+l/2);
end;

function  Int_x(f :TMathFunc; x,y,h :Float) :Float;
begin
  Result := h*f(x+h/2,y);
end;

function  Int_y(f :TMathFunc; x,y,l :Float) :Float;
begin
  Result := l*f(x,y+l/2);
end;

function  DifL_i(f :TMathFunc; x,y,h :Float) :Float;
begin
  Result := (f(x,y) - f(x-h,y))/h;
end;

function  DifR_i(f :TMathFunc; x,y,h :Float) :Float;
begin
  Result := (f(x+h,y) - f(x,y))/h;
end;

function  DifC_i(f :TMathFunc; x,y,h :Float) :Float;
begin
  Result := (f(x+h,y) - f(x-h,y))/(2*h);
end;

function  Dif2_i(f :TMathFunc; x,y,h :Float) :Float;
begin
  Result := (f(x+h,y) + f(x-h,y) - 2*f(x,y))/sqr(h);
end;

function  DifL_j(f :TMathFunc; x,y,l :Float) :Float;
begin
  Result := (f(x,y) - f(x,y-l))/l;
end;

function  DifR_j(f :TMathFunc; x,y,l :Float) :Float;
begin
  Result := (f(x,y+l) - f(x,y))/l;
end;

function  DifC_j(f :TMathFunc; x,y,l :Float) :Float;
begin
  Result := (f(x,y+l) - f(x,y-l))/(2*l);
end;

function  Dif2_j(f :TMathFunc; x,y,l :Float) :Float;
begin
  Result := (f(x,y+l) + f(x,y-l) - 2*f(x,y))/sqr(l);
end;

end.
