unit InOut;

interface

uses Basis,Differences;

procedure WriteToXYZ(filename :String; const A :TMatrix);
procedure WriteToCSV(filename :String; const A :TMatrix);

implementation

uses SysUtils;

procedure WriteToXYZ(filename :String; const A :TMatrix);
var
  f :TextFile;
  i,j :Integer;
begin
  AssignFile(f,filename);
  Rewrite(f);
  writeln(f,'X  ','Y  ','Z');
  for i := 0 to n do begin
    for j := 0 to m do begin
      writeln(f,x(i),' ',y(j),' ',A[j,i]);
    end;
  end;
  CloseFile(f);
end;

procedure WriteToCSV(filename :String; const A :TMatrix);
var
  f :TextFile;
  i,j :Integer;
begin
  AssignFile(f,filename);
  Rewrite(f);
  for i := 0 to m do begin
    for j := 0 to n do begin
      writeln(f,FloatToStr(x(i)),',',FloatToStr(y(j)),',',FloatToStr(A[i,j]));
    end;
  end;
  CloseFile(f);
end;

end.
